package helpdeskClient;

import java.io.*;
import java.security.GeneralSecurityException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.interfaces.RSAPrivateKey;
import java.security.spec.PKCS8EncodedKeySpec;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

public class SystemMessage implements Serializable
{

	protected static final long serialVersionUID = 1112122200L;

	public static final int TALKTOWHO = 0, MESSAGE = 1, LOGOUT = 2, LOGIN=3, TRANSFER=4, UPGRADE=5;
	private String fromWho;
	private String toWho;
	private int type;
	private byte[] message;


	public SystemMessage(String fromWho, String toWho, int type, String message)
	{
		this.fromWho = fromWho;
		this.toWho = toWho;
		this.type = type;
		
		try
		{
			FileInputStream fis1 = new FileInputStream("src/private");
			byte[] privByte = new byte[fis1.available()];
			fis1.read(privByte);
			fis1.close();
			RSAPrivateKey priv = (RSAPrivateKey) KeyFactory.getInstance("RSA").generatePrivate(new PKCS8EncodedKeySpec(privByte));
			byte[] myKey = new byte[8];
			for (int i = 0; i < 7; i ++)
			{
				myKey[i] = priv.getEncoded()[i];
			}
			Key secret = new SecretKeySpec(myKey, "DES");
			Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
			cipher.init(Cipher.ENCRYPT_MODE, secret);
			byte[] ct = cipher.doFinal(message.getBytes());
			this.message = ct;
		} catch (GeneralSecurityException e)
		{
			e.printStackTrace();
		}catch (IOException ee)
		{
			ee.printStackTrace();
		}
	}

	public String getFromWho()
	{
		return fromWho;
	}
	
	public String getToWho()
	{
		return toWho;
	}

	public int getType()
	{
		return type;
	}
	
	public void setType(int type)
	{
		this.type = type;
	}

	public byte[] getMessage()
	{
		return message;
	}
}