package helpdeskClient;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

public class UpgradeWindow extends JDialog implements ActionListener, WindowListener
{
	private static final long serialVersionUID = 1L;
	private JLabel username, passwd, conPasswd;
	private JTextField nameField;
	private JPasswordField passwdField, conPasswdField;
	private JButton okay;
	private boolean done;

	boolean isDone()
	{
		return done;
	}

	String getUsername()
	{
		return nameField.getText();
	}

	@SuppressWarnings("deprecation")
	String getPasswd()
	{
		return passwdField.getText();
	}

	public UpgradeWindow(JFrame frame, boolean modal)
	{
		super(frame, modal);
		done = false;

		JPanel up = new JPanel();
		up.setLayout(new BoxLayout(up, BoxLayout.X_AXIS));
		username = new JLabel("Username :               ");
		nameField = new JTextField(20);
		up.add(username);
		up.add(Box.createRigidArea(new Dimension(20, 0)));
		up.add(nameField);

		JPanel mid = new JPanel();
		mid.setLayout(new BoxLayout(mid, BoxLayout.X_AXIS));
		passwd = new JLabel("Password :                ");
		passwdField = new JPasswordField(20);
		mid.add(passwd);
		mid.add(Box.createRigidArea(new Dimension(20, 0)));
		mid.add(passwdField);

		JPanel down = new JPanel();
		down.setLayout(new BoxLayout(down, BoxLayout.X_AXIS));
		conPasswd = new JLabel("Confirm Password :");
		conPasswdField = new JPasswordField(20);
		down.add(conPasswd);
		down.add(Box.createRigidArea(new Dimension(20, 0)));
		down.add(conPasswdField);

		JPanel center = new JPanel();
		center.setLayout(new GridLayout(3, 1));
		center.add(up);
		center.add(mid);
		center.add(down);

		JPanel bottom = new JPanel();
		bottom.setLayout(new FlowLayout(FlowLayout.CENTER));
		okay = new JButton("OK");
		okay.addActionListener(this);
		bottom.add(okay);

		setLayout(new BorderLayout());
		add(center, BorderLayout.CENTER);
		add(bottom, BorderLayout.SOUTH);
		this.addWindowListener(this);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setTitle("Create Help Desk user account");
		this.pack();
		this.setVisible(true);
	}

	@SuppressWarnings("deprecation")
	@Override
	public void actionPerformed(ActionEvent ae)
	{
		if (okay == ae.getSource())
		{
			if (!passwdField.getText().equals(conPasswdField.getText()))
			{
				JOptionPane.showMessageDialog(null, "Two passwords do not match!");
				return;
			}
			if (passwdField.getText().length() < 4)
			{
				JOptionPane.showMessageDialog(null, "Passwords is at least 4 charactors long!");
				return;
			}
			if (nameField.getText().length() < 3 || !nameField.getText().substring(0, 2).equalsIgnoreCase("hd"))
			{
				JOptionPane.showMessageDialog(null, "Username must starts with \"hd\" and at least 3 characters long");
				return;
			}
			this.done = true;
			this.setVisible(false);
		}
		
	}

	@Override
	public void windowActivated(WindowEvent arg0)
	{
	}

	@Override
	public void windowClosed(WindowEvent arg0)
	{
		this.done = true;
	}

	@Override
	public void windowClosing(WindowEvent arg0)
	{
	}

	@Override
	public void windowDeactivated(WindowEvent arg0)
	{
	}

	@Override
	public void windowDeiconified(WindowEvent arg0)
	{
	}

	@Override
	public void windowIconified(WindowEvent arg0)
	{
	}

	@Override
	public void windowOpened(WindowEvent arg0)
	{
	}
}
