package helpdeskServer;

import helpdeskClient.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.security.GeneralSecurityException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.interfaces.RSAPrivateKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.util.ArrayList;
import java.util.Date;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

class ClientThread extends Thread
{
	Socket socket;
	ObjectInputStream sInput;
	ObjectOutputStream sOutput;
	int id;
	int[] position = new int[2];
	String username, passwd;
	SystemMessage cm;
	String date;
	Server server;

	ClientThread(Server server, Socket socket)
	{
		this.server = server;
		ArrayList<ClientThread> al = server.getAl();
		this.id = Server.uniqueId;
		this.socket = socket;
	
		try
		{
			sOutput = new ObjectOutputStream(socket.getOutputStream());
			sInput = new ObjectInputStream(socket.getInputStream());
			
			String[] userPass = {"",""};
			try
			{
				FileInputStream fis1 = new FileInputStream("src/private");
				byte[] privByte = new byte[fis1.available()];
				fis1.read(privByte);
				fis1.close();
				RSAPrivateKey priv = (RSAPrivateKey) KeyFactory.getInstance("RSA").generatePrivate(new PKCS8EncodedKeySpec(privByte));
				byte[] myKey = new byte[8];
				for (int i = 0; i < 7; i ++)
				{
					myKey[i] = priv.getEncoded()[i];
				}
				Key secret = new SecretKeySpec(myKey, "DES");
				Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
				cipher.init(Cipher.DECRYPT_MODE, secret);
				byte[] back = cipher.doFinal((byte[]) sInput.readObject());
				userPass = (new String(back)).split(",");
			}
			catch (GeneralSecurityException e)
			{
				e.printStackTrace();
				return;
			}
			username = userPass[0].trim();
			passwd = userPass[1].trim();
			if (username.length() > 1 && username.substring(0, 2).equalsIgnoreCase("HD"))
			{
				boolean exist = false;
				username = username.toUpperCase();
				for (ClientThread ct : al)
				{
					if (ct.username.equals(username))
					{
						writeMsg(new SystemMessage("server", username, SystemMessage.LOGOUT, "the account is already logged in"));
						server.display(username
								+ " tried to log in, but failed since the account has already logged in.");
						exist = true;
						server.removeId(id);
						close();
					}
				}
				if (!exist)
				{
					if (server.accountMap.get(username) == null
							|| !server.accountMap.get(username).equals(passwd))
					{
						writeMsg(new SystemMessage("server", username, SystemMessage.LOGOUT, "Username or Password wrong!"));
						server.display(username + " tried to log in, but failed.");
						server.removeId(id);
						close();
					} else
					{
						writeMsg(new SystemMessage("server", username, SystemMessage.LOGIN,
								username));
						position = server.addUser(username, id);
						al.add(this);

						updateOthers(position[0], position[1]);
						updateConversation();

						server.display("help desk user " + username + " just connected.");
					}
				}
			} else
			{
				String temp = "";
				if (id < 10)
				{
					temp = "00" + id;
				} else if (id < 100)
				{
					temp = "0" + id;
				} else
				{
					temp = "" + id;
				}
				username = "Anonymous" + temp;

				position = server.addUser(username, id);
				writeMsg(new SystemMessage("server", username, SystemMessage.LOGIN,
						server.online.get(position[0]).get(0)));
				al.add(this);

				updateOthers(position[0], position[1]);
				updateConversation();
				server.display("anonymous user " + username + " just connected.");
			}
		} catch (IOException e)
		{
			server.display("Exception creating new Input/output Streams: " + e);
			return;
		}
		catch (ClassNotFoundException e)
		{
		}
		date = new Date().toString() + "\n";
	}

	public void run()
	{
		while (true)
		{
			try
			{
				cm = (SystemMessage) sInput.readObject();
			} catch (IOException e)
			{
				server.display(username + " Exception reading Streams: " + e);
				break;
			} catch (ClassNotFoundException e2)
			{
				e2.printStackTrace();
				break;
			}
			String message = "";
			try
			{
				FileInputStream fis1 = new FileInputStream("src/private");
				byte[] privByte = new byte[fis1.available()];
				fis1.read(privByte);
				fis1.close();
				RSAPrivateKey priv = (RSAPrivateKey) KeyFactory.getInstance("RSA").generatePrivate(new PKCS8EncodedKeySpec(privByte));
				byte[] myKey = new byte[8];
				for (int i = 0; i < 7; i ++)
				{
					myKey[i] = priv.getEncoded()[i];
				}
				Key secret = new SecretKeySpec(myKey, "DES");
				Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
				cipher.init(Cipher.DECRYPT_MODE, secret);
				byte[] back = cipher.doFinal(cm.getMessage());
				message = new String(back);
			}
			catch (IOException ee)
			{
				ee.printStackTrace();
			}
			catch (GeneralSecurityException e)
			{
				e.printStackTrace();
				break;
			}
			int type = cm.getType(); 
			String to = cm.getToWho();
			String from = cm.getFromWho();

			if (type == SystemMessage.UPGRADE)
			{
				if (to.equals(""))
				{
					String[] account = message.split(",");
					if (account.length == 0)
					{
						continue;
					}
					String newn = account[0].toUpperCase();
					String newp =account[1];
					int id = server.getId(from);
					ClientThread user = server.getThread(id);
					server.deleteUser(from, id);
					server.accountMap.put(newn, newp);

					user.username = newn;
					user.position = server.addUser(newn, id);
					user.updateConversation();
					user.writeMsg(new SystemMessage("server", newn, SystemMessage.UPGRADE, ""));
					user.updateOthers(user.position[0], user.position[1]);
				}
				else
				{
					int id = server.getId(to);
					ClientThread user = server.getThread(id);
					user.writeMsg(new SystemMessage("server", to, SystemMessage.UPGRADE, ""));
				}
			}
			else if (type == SystemMessage.TRANSFER)
			{
				String[] result = message.split(",");
				String user = result[0];
				String hd = result[1];
				int id = server.getId(user);

				ClientThread one = server.getThread(id);
				one.position = server.transferUser(user, hd);
				one.updateConversation();
				one.writeMsg(new SystemMessage("server", user, SystemMessage.LOGIN, hd));
				id = server.getId(hd);
				ClientThread hdthread = server.getThread(id);
				hdthread.updateConversation();
				updateConversation();
			}
			else if (type == SystemMessage.LOGOUT)
			{
				if (username.substring(0, 2).equalsIgnoreCase("HD"))
				{
					if (server.online.size() == 1 && server.online.get(0).size() > 1)
					{
						this.writeMsg(new SystemMessage("", username, SystemMessage.LOGOUT, "You are the only HD user, cannot logout!"));
						continue;
					}
				}
				server.display(username + " disconnected with a LOGOUT message.");
				this.writeMsg(new SystemMessage("server", username, SystemMessage.TALKTOWHO, ""));
				this.writeMsg(new SystemMessage("server", username, SystemMessage.LOGOUT, username + " has just logged out"));
				break;
			}
			else if (type == SystemMessage.MESSAGE)
			{
				message = from + " says to " + to + ": " + message + "\n";
				this.writeMsg(new SystemMessage(from, to, SystemMessage.MESSAGE, message));

				int id = server.getId(to);
				ClientThread one = server.getThread(id);
				if (!one.writeMsg(new SystemMessage(from, to, SystemMessage.MESSAGE, message)))
				{
					server.removeId(id);
					server.display("Disconnected Client " + one.username + " removed from list.");
				}
				server.pw1.print(server.sdf.format(new Date()) + " " + message);
			}
			else if (type == SystemMessage.TALKTOWHO)
			{
				updateConversation();
			}
		}
		server.removeId(id);
		close();
	}

	private void close()
	{
		server.deleteUser(this.username, this.id);
		updateOthers(position[0], position[1]);
		server.removeId(id);

		try
		{
			if (sOutput != null)
			{
				sOutput.close();
			}
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
		try
		{
			if (sInput != null)
			{
				sInput.close();
			}
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
		try
		{
			if (socket != null)
			{
				socket.close();
			}
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	void updateConversation()
	{
		String returnmsg = "";
		if (username.substring(0, 2).equalsIgnoreCase("HD"))
		{
			for (int i = 0; i < server.online.size(); i++)
			{
				if (!server.online.get(i).get(0).equals(username))
				{
					returnmsg += server.online.get(i).get(0) + ",";
				}
			}
			for (int i = 1; i < server.idlist.get(position[0]).size(); i++)
			{
				returnmsg += server.online.get(position[0]).get(i) + ",";
			}
		}
		
		else
		{ 
			returnmsg = server.online.get(position[0]).get(0);
			if (returnmsg == null)
				returnmsg = "";
		}
		writeMsg(new SystemMessage("server", username, SystemMessage.TALKTOWHO, returnmsg));
	}

	private void updateOthers(int i, int j)
	{
		if (j == 0)
		{
			for (int k = 0; k < server.online.size(); k++)
			{
				int id = server.idlist.get(k).get(0);
				if (id != 0)
				{
					server.getThread(id).updateConversation();
				}
			}
		}
		else
		{
			int id = server.idlist.get(i).get(0);
			if (id != 0)
			{
				server.getThread(id).updateConversation();
			}
		}
	}

	private boolean writeMsg(SystemMessage msg)
	{
		if (!socket.isConnected())
		{
			close();
			return false;
		}
		try
		{
			sOutput.writeObject(msg);
		}
		catch (IOException e)
		{
			server.display("Error sending message to " + username);
			server.display(e.toString());
		}
		return true;
	}
}
