package helpdeskServer;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.FileNotFoundException;

public class ServerGUI extends JFrame implements ActionListener, WindowListener
{

	private static final long serialVersionUID = 1L;
	private JButton stopStart;
	private JTextArea event;
	private JTextField tPortNumber;
	private Server server;

	ServerGUI(int port)
	{
		super("Help Desk Server");
		server = null;
		JPanel north = new JPanel();
		north.add(new JLabel("Port number: "));
		tPortNumber = new JTextField("  " + port);
		north.add(tPortNumber);
		stopStart = new JButton("Start");
		stopStart.addActionListener(this);
		north.add(stopStart);
		add(north, BorderLayout.NORTH);

		event = new JTextArea(100, 100);
		event.setEditable(false);
		appendEvent("Events log.\n");
		add(new JScrollPane(event));

		addWindowListener(this);
		setSize(500, 700);
		setVisible(true);
	}

	
	void appendEvent(String str)
	{
		event.append(str);
		event.setCaretPosition(event.getText().length() - 1);

	}

	public void actionPerformed(ActionEvent e)
	{
		if (server != null)
		{
			server.stop();
			server = null;
			tPortNumber.setEditable(true);
			stopStart.setText("Start");
			return;
		}
		int port;
		try
		{
			port = Integer.parseInt(tPortNumber.getText().trim());
		} catch (Exception er)
		{
			appendEvent("Invalid port number");
			return;
		}
		try
		{
			server = new Server(port, this);
		} catch (FileNotFoundException e1)
		{
			e1.printStackTrace();
		}
		new ServerRunning().start();
		stopStart.setText("Stop");
		tPortNumber.setEditable(false);
	}

	public static void main(String[] arg)
	{
		new ServerGUI(9525);
	}

	public void windowClosing(WindowEvent e)
	{
		if (server != null)
		{
			try
			{
				server.stop(); 
			} catch (Exception eClose)
			{
			}
			server = null;
		}
		dispose();
		System.exit(0);
	}

	public void windowClosed(WindowEvent e)
	{
	}

	public void windowOpened(WindowEvent e)
	{
	}

	public void windowIconified(WindowEvent e)
	{
	}

	public void windowDeiconified(WindowEvent e)
	{
	}

	public void windowActivated(WindowEvent e)
	{
	}

	public void windowDeactivated(WindowEvent e)
	{
	}

	class ServerRunning extends Thread
	{
		public void run()
		{
			server.start(); 
			stopStart.setText("Start");
			tPortNumber.setEditable(true);
			appendEvent("Server crashed\n");
			server = null;
		}
	}

}
